clear
%dati
lg=5;           %lunghezza generatore sequenza PN (3-8)
LnInfo=2000;    %lunghezza sequenza informazione
p0=.5;          %probabilit '0'
SF=16;          %spreading factor (se '1' si simula lo scrambler)
bits_to_show=50;%bit da visualizzare nei grafici
offset=0;       %tra le sequenza PN al trasmettitore e quella al ricevitore
%fine dati
period=2^lg-1;  %periodo sequenza PN
periods=ceil(LnInfo*SF/period); %periodi generati
switch lg       %generatori sequenze PN in ottale
    case 3
        gn=[3];
    case 4
        gn=[0 3];
    case 5
        gn=[0 5];
    case 6
        gn=[0 3];
    case 7
        gn=[0 1 1];
    case 8
        gn=[0 3 5];
    otherwise
        disp('error')
end

inPN=ones(1,period*periods);
ouPNbin=scrambler(inPN,gn,lg);           %generazione sequenza PN
ouPNap=1-2*ouPNbin;                      %formato antipodale
[y, cy] = corrcoeff(ouPNap,period);      %coefficiente di correlazione
stem(0:period-1,y);
title('coefficiente di autocorrelazione');

inInfobin=rand(1,LnInfo)>p0;             %sequenza info in binario
inInfoSmbin=inInfobin'*ones(1,SF);       %replica per espansione di spettro
inInfoSbin=reshape(inInfoSmbin',1,prod(size(inInfoSmbin))); %sequenza info espansa
inInfoSap=1-2*inInfoSbin;                %sequenza info espansa in antipodale

outInfoSbin=xor(inInfoSbin,ouPNbin(1:length(inInfoSbin)));
rebInfoSbin=xor(outInfoSbin,ouPNbin(1:length(inInfoSbin))); %correct despread binary

ouPNsbin=[ouPNbin(1+offset:length(ouPNbin)),ouPNbin(1:offset)];
rebInfoSsbin=xor(outInfoSbin,ouPNsbin(1:length(inInfoSbin))); %offset despread binary

outInfoSap=1-2*outInfoSbin;   %antipodal spread

rebInfoSap=1-2*rebInfoSbin;    %correct despread antipodal
rebInfoSsap=1-2*rebInfoSsbin;  %offset despread antipodal

rebInfoSmap=(reshape(rebInfoSap,SF,LnInfo))';
rebInfobin=(sum(rebInfoSmap,2)<0)';   %correct decision

rebInfoSsmap=(reshape(rebInfoSsap,SF,LnInfo))';
rebInfosbin=(sum(rebInfoSsmap,2)<0)';  %offset decision

figure;
subplot(4,1,1);
stem(inInfobin(1:bits_to_show));
title('user data');
set(gca,'YLim',[0,1]);
subplot(4,1,2);
stem(outInfoSbin(1:bits_to_show*SF));
set(gca,'YLim',[0,1]);
if SF==1
    tt1=sprintf('user scrambled data');
    tt2=sprintf('user de-scrambled data');
else
    tt1=sprintf('user expanded data (SF=%d)',SF);
    tt2=sprintf('user de-expanded data (SF=%d)',SF);
end
title(tt1);
subplot(4,1,3);
stem(rebInfoSsap(1:bits_to_show*SF)<0,'k*');
set(gca,'YLim',[0,1]);
title(tt2);
subplot(4,1,4);
stem(rebInfosbin(1:bits_to_show),'ko');
title('user received data');
set(gca,'YLim',[0,1]);

if SF>1   %plot spectra
    t1=(abs(fft(outInfoSap))).^2;
    t2=(abs(fft(rebInfoSap))).^2;
    t1=t1/max(t2);
    t2=t2/max(t2);
    plot_power_spectrum2(t1,SF,1,'k',0);
    plot_power_spectrum2(t2,SF,0,'r',0);
    set(gca,'YLim',[-50,0]);
    title('spread sequence (black), despread (red)');
end